package com.pictures;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.json.JSONException;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Bitmap.CompressFormat;
import android.graphics.BitmapFactory;
import android.graphics.PixelFormat;
import android.hardware.Camera;
import android.os.Bundle;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.TextView;

public class CameraView extends Activity implements SurfaceHolder.Callback, OnClickListener
	 {
	static final int FOTO_MODE = 0;
	private static final String TAG = "CameraTest";
	Camera mCamera;
	boolean mPreviewRunning = false;
	private Context mContext = this;
	private SurfaceView mSurfaceView;
	private SurfaceHolder mSurfaceHolder;
	private Button mButton;
    private TextView mTextview;
	private ProgressDialog mSpinner;	
	String filename;
	public void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		getWindow().setFormat(PixelFormat.TRANSLUCENT);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		
		setContentView(R.layout.camera);
		
		mButton=(Button) findViewById(R.id.Back);
		mTextview=(TextView) findViewById(R.id.info);
		
		
		mSurfaceView = (SurfaceView) findViewById(R.id.surface_camera);
		mSurfaceView.setOnClickListener(this);
		mSurfaceHolder = mSurfaceView.getHolder();
		mSurfaceHolder.addCallback(this);
		mSurfaceHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
		
		mSpinner = new ProgressDialog(mSurfaceView.getContext());
        mSpinner.requestWindowFeature(Window.FEATURE_NO_TITLE);
        mSpinner.setMessage("sending...");

       
		mButton.setOnClickListener(new Button.OnClickListener() {
	        public void onClick(View v){
	        	finish();	            
	        }
	        });	
	}
	
   	@Override
	protected void onRestoreInstanceState(Bundle savedInstanceState) {
		super.onRestoreInstanceState(savedInstanceState);
	}

	Camera.PictureCallback mPictureCallback = new Camera.PictureCallback() {
		public void onPictureTaken(byte[] imageData, Camera c) {
		
			if (imageData != null) {

				Intent mIntent = new Intent();

				try {
					StoreByteImage(mContext, imageData, 50,
							"ImageName");
				} catch (ParseException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
    			mCamera.startPreview();

				setResult(FOTO_MODE, mIntent);
				AlertDialog.Builder builder = new AlertDialog.Builder(mContext);
				builder.setMessage("Do you want to send it for object recognition?")
				       .setCancelable(true)
				       .setPositiveButton("Yes", new DialogInterface.OnClickListener() {
				           public void onClick(DialogInterface dialog, int id) {
				        	  //mSpinner.show();
				        	  dialog.cancel();
				        	       	final Inquiry iqr=new Inquiry();
								    iqr.query(filename);
								    
								    try {
								    	Thread.sleep(20000);
										iqr.result();
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									} catch (JSONException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
						            mTextview.setText(iqr.getResult());								
					                     
								    //final Handler handler=new Handler();
								   /* final Runnable r = new Runnable()
								    {
								        public void run() 
								        {
								         try {
								            //handler.postDelayed(this, 20000);
								            iqr.result();
								            mSpinner.dismiss();
								            mTextview.setText(iqr.getResult());	               
									    
								            
								         } catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											} catch (JSONException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
								        }
								    };

								    handler.postDelayed(r, 20000);	*/   
							
							}   	
						          

						
				       })
				       .setNegativeButton("No", new DialogInterface.OnClickListener() {
				           public void onClick(DialogInterface dialog, int id) {
				              dialog.cancel();
				           }
				       });
				AlertDialog alert = builder.create();
				alert.show();			

			}
		}
	};
	
	protected void onResume() {
		Log.e(TAG, "onResume");
		super.onResume();		
	       
	}

	protected void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
	}

	protected void onStop() {
		Log.e(TAG, "onStop");
		super.onStop();
	}

	public void surfaceCreated(SurfaceHolder holder) {
		Log.e(TAG, "surfaceCreated");
		mCamera = Camera.open();		    
	}

	public void surfaceChanged(SurfaceHolder holder, int format, int w, int h) {
		Log.e(TAG, "surfaceChanged");

		// XXX stopPreview() will crash if preview is not running
		if (mPreviewRunning) {
			mCamera.stopPreview();
		}

		Camera.Parameters p = mCamera.getParameters();
		p.setPreviewSize(w, h);
		mCamera.setParameters(p);
		try {
			mCamera.setPreviewDisplay(holder);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		mCamera.startPreview();
		mPreviewRunning = true;
		
	}

	public void surfaceDestroyed(SurfaceHolder holder) {
		Log.e(TAG, "surfaceDestroyed");
		mCamera.stopPreview();
		mPreviewRunning = false;
		mCamera.release();
		 
	}

	public void onClick(View arg0) {

		
		mCamera.takePicture(null, mPictureCallback, mPictureCallback);
		

	}
	
	public  boolean StoreByteImage(Context mContext, byte[] imageData,
			int quality, String expName) throws ParseException {

        File sdImageMainDirectory = new File("/sdcard");
		FileOutputStream fileOutputStream = null;
		try {

			BitmapFactory.Options options=new BitmapFactory.Options();
			options.inSampleSize = 5;
			
			Bitmap myImage = BitmapFactory.decodeByteArray(imageData, 0,
					imageData.length,options);
 
			SimpleDateFormat format = new SimpleDateFormat("ddMMyyyyHHmmss");
			String myDate = format.format(new Date());
			String s="image".concat(myDate);
			filename=sdImageMainDirectory.toString() + "/" + s + ".jpg";
			fileOutputStream = new FileOutputStream(filename);
							
  
			BufferedOutputStream bos = new BufferedOutputStream(
					fileOutputStream);

			myImage.compress(CompressFormat.JPEG, quality, bos);

			bos.flush();
			bos.close();

		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return true;
	}

}
