package com.pictures;

import org.json.JSONException;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.TextView;


public class ImageView extends Activity {
    private android.widget.ImageView imageview;
	private Button backButton;
	private Button sendQueryButton;
	private ProgressDialog mSpinner;
	private TextView info;
	String filename;
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.imageview);
        imageview=(android.widget.ImageView)findViewById(R.id.image);
        backButton= (Button)  findViewById(R.id.back);
        sendQueryButton=(Button)  findViewById(R.id.send);
        info=(TextView)findViewById(R.id.info);
        filename="";
        // get image file URL
        Intent myIntent = getIntent();
        filename= (String) myIntent.getStringExtra("com.pictures.filename");
        
        loadImage();
        
        
              
        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        mSpinner = new ProgressDialog(imageview.getContext());
        mSpinner.requestWindowFeature(Window.FEATURE_NO_TITLE);
        mSpinner.setMessage("Loading...");
        ///////////////////////////////////////////////////////////////////////////////////////////////////////
        backButton.setOnClickListener(new Button.OnClickListener() {
	        public void onClick(View v){
	        	finish();
	        }
	        });     
        sendQueryButton.setOnClickListener(new Button.OnClickListener() {
	        public void onClick(View v){
	        	sendQuery(filename);
	        }
	        });     
              
 }
	public void sendQuery(String filename)	{
		 mSpinner.show();
   	   	 final Inquiry iqr=new Inquiry();
		 iqr.query(filename);
		 final Handler handler=new Handler();
		 final Runnable r = new Runnable(){
			  public void run() {
			         try {
			            //handler.postDelayed(this, 20000);
			            iqr.result();
			            mSpinner.dismiss();
			            info.setText(iqr.getResult());			           
			            
			         } catch (InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (JSONException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
			        }
			    };
          handler.postDelayed(r, 20000);	  
	}	
	public void loadImage(){
		Bitmap bMap = BitmapFactory.decodeFile(filename);
        imageview.setImageBitmap(bMap);
	}	

}
